package raft.glfont.android;

/**
 * @author hakan eryargi (r a f t)
 *         http://www.jpct.net/forum2/index.php?topic=1563.0
 */
public class Rectangle {
	public int x;
	public int y;
	public int width;
	public int height;

	public Rectangle() {
		this(0, 0, 0, 0);
	}

	public Rectangle(Rectangle r) {
		this(r.x, r.y, r.width, r.height);
	}

	public Rectangle(int x, int y, int width, int height) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}

	public Rectangle(int width, int height) {
		this(0, 0, width, height);
	}

	public void set(Rectangle r) {
		this.x = r.x;
		this.y = r.y;
		this.width = r.width;
		this.height = r.height;
	}

	public Rectangle translate(int dX, int dY) {
		this.x += dX;
		this.y += dY;
		return this;
	}

	@Override
	public String toString() {
		return "Rectangle " + this.x + "," + this.y + " " + this.width + "," + this.height;
	}

	public Rectangle grow(int amount) {
		this.x -= amount;
		this.y -= amount;
		this.width += amount + amount;
		this.height += amount + amount;
		return this;
	}

	public void setLocation(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public boolean contains(int x, int y) {
		return (this.x <= x) && (this.y <= y) && (this.x + this.width >= x) && (this.y + this.height >= y);
	}

}
