package tjm.tdg;

import android.app.Activity;
import android.content.Context;
import android.media.AudioManager;
import android.os.Bundle;
import android.view.Menu;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;

public class SettingsActivity extends Activity {
	private SeekBar seekBarMaster = null;
	private SeekBar seekBarBackground = null;
	private SeekBar seekBarEffect = null;
	private AudioManager audioManager = null;
	private static int volumeMax = -1;
	private static int volumeBackground = -1;
	private static int volumeEffect = -1;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_settings);

		this.audioManager = (AudioManager) getSystemService(Context.AUDIO_SERVICE);

		int max = this.audioManager.getStreamMaxVolume(AudioManager.STREAM_MUSIC);
		int now = this.audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);

		if (volumeMax == -1 || volumeBackground == -1 || volumeEffect == -1) {
			volumeMax = max;
			setVolumeBackground(now);
			setVolumeEffect(now);
		}

		this.seekBarMaster = (SeekBar) findViewById(R.id.seekBarMaster);
		this.seekBarMaster.setMax(max);
		this.seekBarMaster.setProgress(now);

		this.seekBarBackground = (SeekBar) findViewById(R.id.seekBarBackground);
		this.seekBarBackground.setMax(now);
		this.seekBarBackground.setProgress(volumeBackground);

		this.seekBarEffect = (SeekBar) findViewById(R.id.seekBarEffect);
		this.seekBarEffect.setMax(now);
		this.seekBarEffect.setProgress(volumeEffect);

		try {
			this.seekBarMaster.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
				@Override
				public void onStopTrackingTouch(SeekBar arg0) {
				}

				@Override
				public void onStartTrackingTouch(SeekBar arg0) {
				}

				@Override
				public void onProgressChanged(SeekBar arg0, int progress, boolean arg2) {
					SettingsActivity.this.audioManager.setStreamVolume(AudioManager.STREAM_MUSIC, progress, 0);
					SettingsActivity.this.seekBarBackground.setMax(progress);
					SettingsActivity.this.seekBarEffect.setMax(progress);
				}
			});

			this.seekBarBackground.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
				@Override
				public void onStopTrackingTouch(SeekBar arg0) {
				}

				@Override
				public void onStartTrackingTouch(SeekBar arg0) {
				}

				@Override
				public void onProgressChanged(SeekBar arg0, int progress, boolean arg2) {
					setVolumeBackground(progress);
				}
			});

			this.seekBarEffect.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
				@Override
				public void onStopTrackingTouch(SeekBar arg0) {
				}

				@Override
				public void onStartTrackingTouch(SeekBar arg0) {
				}

				@Override
				public void onProgressChanged(SeekBar arg0, int progress, boolean arg2) {
					setVolumeEffect(progress);
				}
			});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		return true;
	}

	private void setVolumeBackground(int vol) {
		volumeBackground = vol;
		Settings.volBackground = (float) volumeBackground / volumeMax;
	}

	private void setVolumeEffect(int vol) {
		volumeEffect = vol;
		Settings.volEffect = (float) volumeEffect / volumeMax;
	}
}
