package tjm.tdg.entities;

public enum EntityType {
	// entity
	ENTITY(EntityType.TYPE_ENTITY),

	// mobs
	MOB(EntityType.TYPE_MOB),

	KAMIKAZE(EntityType.TYPE_MOB),

	TACTICAL(EntityType.TYPE_MOB),

	BERSERKER(EntityType.TYPE_MOB),

	// towers
	TOWER(EntityType.TYPE_TOWER),

	TOWER_BASE(EntityType.TYPE_TOWER),

	TOWER_BASIC(EntityType.TYPE_TOWER),

	TOWER_LONG_RANGE(EntityType.TYPE_TOWER),

	TOWER_SPLASH(EntityType.TYPE_TOWER),

	// projectiles
	PROJECTILE(EntityType.TYPE_PROJECTILE),

	PROJECTILE_ALLY(EntityType.TYPE_PROJECTILE),

	PROJECTILE_ENEMY(EntityType.TYPE_PROJECTILE),

	// world objects
	WORLD_OBJECT(EntityType.TYPE_OBJECT),

	ROCK(EntityType.TYPE_OBJECT);

	private static final int TYPE_ENTITY = 0x00;
	private static final int TYPE_MOB = 0x01;
	private static final int TYPE_TOWER = 0x02;
	private static final int TYPE_PROJECTILE = 0x04;
	private static final int TYPE_OBJECT = 0x08;

	public static final EntityType[] ATTACKABLE = {
			KAMIKAZE, TACTICAL, BERSERKER, TOWER_BASE, TOWER_BASIC, TOWER_LONG_RANGE, TOWER_SPLASH
	};
	public static final EntityType[] MOBS = {
			KAMIKAZE, TACTICAL, BERSERKER
	};
	public static final EntityType[] TOWERS = {
			TOWER_BASE, TOWER_BASIC, TOWER_LONG_RANGE, TOWER_SPLASH
	};
	public static final EntityType[] PROJECTILES = {
			PROJECTILE_ALLY, PROJECTILE_ENEMY
	};

	private int type;

	private EntityType(int typ) {
		this.type = typ;
	}

	public boolean isMob() {
		return this.type == TYPE_MOB;
	}

	public boolean isTower() {
		return this.type == TYPE_TOWER;
	}

	public boolean isProjectile() {
		return this.type == TYPE_PROJECTILE;
	}

	public boolean isWorldObject() {
		return this.type == TYPE_OBJECT;
	}
}
