package tjm.tdg.entities.ai;

import tjm.tdg.ResourceManager;
import tjm.tdg.entities.Entity;
import tjm.tdg.entities.EntityType;
import tjm.tdg.entities.TriBoolean;
import tjm.tdg.entities.projectiles.Projectile;

public class AIAttack extends AITask {
	protected Entity target = null;

	public AIAttack(Entity entitySource) {
		super(entitySource);
	}

	@Override
	public boolean canExecute() {
		this.target = this.entity.closestEntity(EntityType.ATTACKABLE, TriBoolean.NO, TriBoolean.DONT_CARE);
		if (this.target != null && this.entity.isInRange(this.target)) {
			return true;
		}

		this.target = null;

		return false;
	}

	@Override
	public boolean execute(int ticks) {
		if (!this.entity.canAttack()) {
			return true;
		}

		Projectile projectile = this.entity.attack(this.target);
		if (projectile == null) {
			return false;
		}

		ResourceManager.playSound(this.entity.getAttackSound(), 0.05f);
		this.entity.world.addEntity(projectile);
		return true;
	}
}
