package tjm.tdg.entities.ai;

import java.util.List;

import tjm.tdg.ResourceManager;
import tjm.tdg.entities.Entity;
import tjm.tdg.entities.projectiles.Projectile;

public class AIExplode extends AIAttack {
	private List<Entity> targets;

	public AIExplode(Entity entitySource) {
		super(entitySource);
	}

	@Override
	public boolean canExecute() {
		this.targets = this.entity.entitiesInRange(false);
		return this.targets != null && this.targets.size() > 0;
	}

	@Override
	public boolean execute(int ticks) {
		if (!this.entity.canAttack()) {
			return true;
		}

		for (int i = 0; i < this.targets.size(); i++) {
			Projectile projectile = this.entity.attack(this.targets.get(i));

			if (projectile != null) {
				this.entity.world.addEntity(projectile);
			}
		}

		ResourceManager.playSound(this.entity.getAttackSound(), 0.05f);

		this.entity.health = 0;

		return true;
	}
}
