package tjm.tdg.entities.ai;

import tjm.tdg.Settings;
import tjm.tdg.entities.Entity;
import tjm.tdg.utils.Direction;
import tjm.tdg.utils.Vector2f;

public class AIMove extends AITask {
	protected final Vector2f pos = new Vector2f();
	protected final Vector2f directionVector = new Vector2f();

	public AIMove(Entity entitySource) {
		super(entitySource);
	}

	@Override
	public boolean canExecute() {
		return this.entity.waypoints.size() > 0;
	}

	@Override
	public boolean execute(int ticks) {
		Vector2f waypoint = this.entity.waypoints.get(0);

		// correct floating point error that might occur
		if (this.entity.position.equals(waypoint, Settings.SECONDS_PER_TICK * this.entity.walkSpeed)) {
			this.entity.position.copyFrom(waypoint);
			this.entity.waypoints.remove(0);
		}

		this.entity.direction = Direction.getDirection(this.directionVector.set(waypoint.x - this.entity.position.x, waypoint.y - this.entity.position.y));

		move();

		return true;
	}

	protected void move() {
		this.directionVector.copyFrom(this.entity.getDirectionVector());
		this.entity.position.add(this.directionVector.mult(this.entity.walkSpeed * Settings.SECONDS_PER_TICK));
	}
}
