package tjm.tdg.entities.ai;

import tjm.tdg.entities.Entity;
import tjm.tdg.entities.projectiles.Projectile;
import tjm.tdg.utils.Vector2f;

public class AIProjectileAttack extends AIAttack {
	private final Vector2f pos = new Vector2f();
	private final Projectile entityProjectile;

	public AIProjectileAttack(Entity entitySource) {
		super(entitySource);
		this.entityProjectile = (Projectile) entitySource;
	}

	@Override
	public boolean canExecute() {
		this.target = this.entityProjectile.target;
		this.pos.copyFrom(this.entityProjectile.position);
		return this.pos.sub(this.target.position).length() < 10e-1;
	}

	@Override
	public boolean execute(int ticks) {
		this.entityProjectile.target.health -= this.entityProjectile.attackDamage;
		this.entityProjectile.target = null;
		return true;
	}
}
