package tjm.tdg.entities.ai;

import tjm.tdg.entities.Entity;

public abstract class AITask {
	protected Entity entity = null;

	public AITask(Entity entitySource) {
		this.entity = entitySource;
	}

	public abstract boolean canExecute();

	public abstract boolean execute(int ticks);

	public static boolean executeTask(Entity entity, int ticks) {
		for (int i = 0; i < entity.taskList.size(); i++) {
			if (entity.taskList.get(i).canExecute() && entity.taskList.get(i).execute(ticks)) {
				return true;
			}
		}
		return false;
	}
}
