package tjm.tdg.entities.mobs;

import static tjm.tdg.ResourceManager.getModelCopy;
import tjm.tdg.GameWorld;
import tjm.tdg.ResourceManager.MODEL;
import tjm.tdg.ResourceManager.SOUND;
import tjm.tdg.Settings;
import tjm.tdg.entities.EntityType;
import tjm.tdg.entities.Team;
import tjm.tdg.entities.ai.AIAttack;
import tjm.tdg.entities.ai.AIAttackTower;
import tjm.tdg.entities.ai.AIMove;
import tjm.tdg.utils.Vector2f;

public class Berserker extends Mob {
	public Berserker(GameWorld gameWorld, Vector2f pos) {
		super(gameWorld, pos);

		this.model = getModelCopy(MODEL.BERSERKER);

		this.type = EntityType.BERSERKER;

		this.team = Team.ENEMY;
		this.health = this.maxHealth = 50;
		this.walkSpeed = 2.0;
		this.attackSpeed = 45;
		this.attackDamage = 15;
		this.attackRange = 2;

		this.coins = Settings.MOB_REWARD_BERSERKER;

		this.taskList.add(new AIAttackTower(this));
		this.taskList.add(new AIAttack(this));
		this.taskList.add(new AIMove(this));
	}

	@Override
	public String getAttackSound() {
		return SOUND.ATTACK02;
	}
}
