package tjm.tdg.entities.mobs;

import static tjm.tdg.ResourceManager.getModelCopy;
import tjm.tdg.GameWorld;
import tjm.tdg.ResourceManager.MODEL;
import tjm.tdg.Settings;
import tjm.tdg.entities.EntityType;
import tjm.tdg.entities.Team;
import tjm.tdg.entities.ai.AIAttack;
import tjm.tdg.entities.ai.AIAttackTower;
import tjm.tdg.entities.ai.AIExplode;
import tjm.tdg.entities.ai.AIMove;
import tjm.tdg.utils.Vector2f;

public class Kamikaze extends Mob {
	public Kamikaze(GameWorld gameWorld, Vector2f pos) {
		super(gameWorld, pos);

		this.type = EntityType.KAMIKAZE;

		this.model = getModelCopy(MODEL.KAMIKAZE);

		this.team = Team.ENEMY;
		this.health = this.maxHealth = 25;
		this.walkSpeed = 0.8;
		this.attackSpeed = 10;
		this.attackDamage = 250;
		this.attackRange = 2;

		this.coins = Settings.MOB_REWARD_KAMIKAZE;

		this.taskList.add(new AIExplode(this));
		this.taskList.add(new AIAttackTower(this));
		this.taskList.add(new AIAttack(this));
		this.taskList.add(new AIMove(this));
	}
}
