package tjm.tdg.entities.mobs;

import static tjm.tdg.ResourceManager.getModelCopy;
import tjm.tdg.GameWorld;
import tjm.tdg.ResourceManager.MODEL;
import tjm.tdg.Settings;
import tjm.tdg.entities.EntityType;
import tjm.tdg.entities.Team;
import tjm.tdg.entities.ai.AIAttack;
import tjm.tdg.entities.ai.AIAttackBase;
import tjm.tdg.entities.ai.AIAttackTower;
import tjm.tdg.entities.ai.AIMove;
import tjm.tdg.entities.ai.AIMoveDirectlyToBase;
import tjm.tdg.utils.Vector2f;

public class Tactical extends Mob {
	public Tactical(GameWorld gameWorld, Vector2f pos) {
		super(gameWorld, pos);

		this.type = EntityType.TACTICAL;

		this.model = getModelCopy(MODEL.TACTICAL);

		this.team = Team.ENEMY;
		this.health = this.maxHealth = 75;
		this.walkSpeed = 1.2;
		this.attackSpeed = 60;
		this.attackDamage = 20;
		this.attackRange = 3.5;

		this.coins = Settings.MOB_REWARD_TACTICAL;

		this.taskList.add(new AIAttackBase(this));
		this.taskList.add(new AIMoveDirectlyToBase(this));
		this.taskList.add(new AIAttackTower(this));
		this.taskList.add(new AIAttack(this));
		this.taskList.add(new AIMove(this));
	}
}
