package tjm.tdg.entities.projectiles;

import tjm.tdg.GameWorld;
import tjm.tdg.entities.Entity;
import tjm.tdg.utils.Vector2f;

public abstract class Projectile extends Entity {
	public Entity target = null;
	public Vector2f directionVector = new Vector2f();

	public Projectile(GameWorld gameWorld, Vector2f pos, Entity source, Entity destination) {
		this.world = gameWorld;
		this.position = pos.clone();
		this.positionPrev = pos.clone();
		this.radius = new Vector2f(0.3f, 0.02f);
		this.attackDamage = source.attackDamage;
		this.team = source.team;

		this.walkSpeed = 5.0;

		this.target = destination;
		this.isImmortal = true;
		updateAngle();

		this.modelOffsetY = -1.0f;
	}

	@Override
	public boolean isDead() {
		return this.target == null;
	}

	@Override
	public void setDead() {
		this.target = null;
	}

	@Override
	public Vector2f getDirectionVector() {
		return this.directionVector;
	}

	public void updateAngle() {
		if (!isDead()) {
			this.directionVector.set(this.target.position.x - this.position.x, this.target.position.y - this.position.y).normalize();
		}
	}
}
