package tjm.tdg.entities.projectiles;

import static tjm.tdg.ResourceManager.getModelCopy;
import tjm.tdg.GameWorld;
import tjm.tdg.ResourceManager.MODEL;
import tjm.tdg.entities.Entity;
import tjm.tdg.entities.EntityType;
import tjm.tdg.entities.ai.AIProjectileAttack;
import tjm.tdg.entities.ai.AIProjectileMove;
import tjm.tdg.utils.Vector2f;

public class ProjectileAlly extends Projectile {
	public ProjectileAlly(GameWorld gameWorld, Vector2f pos, Entity source, Entity destination) {
		super(gameWorld, pos, source, destination);

		this.type = EntityType.PROJECTILE_ALLY;

		this.model = getModelCopy(MODEL.PROJ_ALLY);

		this.taskList.add(new AIProjectileAttack(this));
		this.taskList.add(new AIProjectileMove(this));
	}
}
