package tjm.tdg.gui;

import tjm.tdg.ResourceManager;

public class GuiControl extends Gui {
	protected final GuiScreen parent;
	public final int id, x, y, width, height;
	public final String background;

	public GuiControl(int id, GuiScreen screen, int x, int y, int width, int height, String image) {
		this.id = id;
		this.parent = screen;
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
		this.background = image;
	}

	@SuppressWarnings("hiding")
	@Override
	public boolean hasClickedInside(int x, int y) {
		return !(x < this.x || (x > this.x + this.width) || y < this.y || y > (this.y + this.height));
	}

	@Override
	public void draw() {
		super.draw();

		if (this.background.length() > 0) {
			ResourceManager.blitImage(this.parent.fb, this.background, this.x, this.y, this.width, this.height);
		}
	}
}
