package tjm.tdg.gui;

import java.util.ArrayList;
import java.util.List;

import tjm.tdg.GameWorld;
import tjm.tdg.Renderer;
import tjm.tdg.ResourceManager;

import com.threed.jpct.FrameBuffer;
import com.threed.jpct.RGBColor;

public class GuiScreen extends Gui {
	protected final GameWorld gameWorld;
	protected final FrameBuffer fb;
	public final int width, height;
	public final List<GuiControl> controls = new ArrayList<GuiControl>();

	public GuiScreen(GameWorld world, FrameBuffer frameBuffer, int width, int height) {
		this.gameWorld = world;
		this.fb = frameBuffer;
		this.width = width;
		this.height = height;
	}

	@Override
	public void draw() {
		super.draw();

		for (int i = 0; i < this.controls.size(); i++) {
			this.controls.get(i).draw();
		}

		drawString(this.fb, ResourceManager.FONT1, "FPS: " + Renderer.fps, 10, 16, RGBColor.WHITE);
	}

	@Override
	public void onClick(int x, int y) {
		for (int i = 0; i < this.controls.size(); i++) {
			GuiControl guiControl = this.controls.get(i);
			if (guiControl.hasClickedInside(x, y)) {
				onClick(guiControl);
			}
		}
	}
}
