package tjm.tdg.gui;

import tjm.tdg.GameWorld;
import tjm.tdg.Renderer;
import tjm.tdg.ResourceManager;
import tjm.tdg.ResourceManager.IMAGE;
import tjm.tdg.TDG;

import com.threed.jpct.FrameBuffer;
import com.threed.jpct.RGBColor;

public class GuiScreenMain extends GuiScreen {
	private final GuiControlButtonCenter btnNewGame;

	public GuiScreenMain(GameWorld world, FrameBuffer frameBuffer, int width, int height) {
		super(world, frameBuffer, width, height);

		int id = 0;
		this.controls.add(this.btnNewGame = new GuiControlButtonCenter(id++, this, this.width / 2 - 64, this.height / 2 - 32, 128, 64, "New game", IMAGE.BUTTON));

	}

	@Override
	public void onClick(GuiControl guiControl) {
		if (guiControl.id == this.btnNewGame.id) {
			Renderer renderer = TDG.renderer;
			renderer.createNewWorld();

			renderer.currentGui = renderer.guiInGame;
		}
	}

	@Override
	public void draw() {
		ResourceManager.blitImage(this.fb, IMAGE.BACKGROUND_MAIN, 0, 0, this.width, this.height);

		super.draw();

		drawStringCenter(this.fb, ResourceManager.FONT3, "Treed", this.width / 2, this.height / 2 - this.height / 8, RGBColor.WHITE);
	}
}
