package tjm.tdg.utils;

public enum Direction {
	NONE(0, 0),

	RIGHT(1, 0),

	UP_RIGHT(MathHelper.sqrt2, -MathHelper.sqrt2),

	UP(0, -1),

	UP_LEFT(-MathHelper.sqrt2, -MathHelper.sqrt2),

	LEFT(-1, 0),

	DOWN_LEFT(-MathHelper.sqrt2, MathHelper.sqrt2),

	DOWN(0, 1),

	DOWN_RIGHT(MathHelper.sqrt2, MathHelper.sqrt2);

	private final static float directionDelta = 0.02f;
	private final Vector2f vector;

	private Direction(float x, float y) {
		this.vector = new Vector2f(x, y);
	}

	private Direction(double x, double y) {
		this.vector = new Vector2f((float) x, (float) y);
	}

	public Vector2f getVector2f() {
		return this.vector;
	}

	public float getX() {
		return this.vector.x;
	}

	public float getY() {
		return this.vector.y;
	}

	public static Direction getDirection(Vector2f vec) {
		if (vec.y > directionDelta) {
			if (vec.x > directionDelta) {
				return Direction.DOWN_RIGHT;
			} else if (vec.x < -directionDelta) {
				return Direction.DOWN_LEFT;
			} else {
				return Direction.DOWN;
			}
		} else if (vec.y < -directionDelta) {
			if (vec.x > directionDelta) {
				return Direction.UP_RIGHT;
			} else if (vec.x < -directionDelta) {
				return Direction.UP_LEFT;
			} else {
				return Direction.UP;
			}
		} else {
			if (vec.x > directionDelta) {
				return Direction.RIGHT;
			} else if (vec.x < -directionDelta) {
				return Direction.LEFT;
			}
		}
		return Direction.NONE;
	}
}
