package tjm.tdg.utils;

public class Vector2f {
	public float x, y;

	public Vector2f() {
		this.x = 0.0f;
		this.y = 0.0f;
	}

	public Vector2f(float x, float y) {
		this.x = x;
		this.y = y;
	}

	public Vector2f set(float x, float y) {
		this.x = x;
		this.y = y;
		return this;
	}

	public Vector2f copyFrom(Vector2f vec) {
		this.x = vec.x;
		this.y = vec.y;
		return this;
	}

	public double length() {
		return Math.sqrt(this.x * this.x + this.y * this.y);
	}

	public Vector2f normalize() {
		double length = Math.sqrt((this.x * this.x) + (this.y * this.y));
		this.x /= length;
		this.y /= length;
		return this;
	}

	public Vector2f add(Vector2f vec) {
		this.x += vec.x;
		this.y += vec.y;
		return this;
	}

	public Vector2f sub(Vector2f vec) {
		this.x -= vec.x;
		this.y -= vec.y;
		return this;
	}

	public Vector2f mult(double num) {
		this.x *= num;
		this.y *= num;
		return this;
	}

	@Override
	public Vector2f clone() {
		return new Vector2f(this.x, this.y);
	}

	public boolean equals(Vector2f vec) {
		return this.equals(vec, 10e-12);
	}

	public boolean equals(Vector2f vec, double delta) {
		return MathHelper.isEqual(this.x, vec.x, delta) && MathHelper.isEqual(this.y, vec.y, delta);
	}
}
