package tjm.tdg.utils;

public class Vector2i {
	public int x, y;

	public Vector2i() {
		this.x = 0;
		this.y = 0;
	}

	public Vector2i(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public Vector2i set(int x, int y) {
		this.x = x;
		this.y = y;
		return this;
	}

	public Vector2i copyFrom(Vector2i vec) {
		this.x = vec.x;
		this.y = vec.y;
		return this;
	}

	public double length() {
		return Math.sqrt(this.x * this.x + this.y * this.y);
	}

	public Vector2i normalize() {
		double length = Math.sqrt((this.x * this.x) + (this.y * this.y));
		this.x /= length;
		this.y /= length;
		return this;
	}

	public Vector2i add(Vector2i vec) {
		this.x += vec.x;
		this.y += vec.y;
		return this;
	}

	public Vector2i sub(Vector2i vec) {
		this.x -= vec.x;
		this.y -= vec.y;
		return this;
	}

	public Vector2i mult(double num) {
		this.x *= num;
		this.y *= num;
		return this;
	}

	@Override
	public Vector2i clone() {
		return new Vector2i(this.x, this.y);
	}

	public boolean equals(Vector2i vec) {
		return this.x == vec.x && this.y == vec.y;
	}
}
